class Unit {
  final String name;
  final String symbol;

  const Unit(this.name, this.symbol);

  Unit.fromJson(Map<String, dynamic> json) : this(json['name'], json['symbol']);

  @override
  String toString() => symbol;

  @override
  bool operator ==(Object other) =>
      identical(this, other) || other is Unit && runtimeType == other.runtimeType && symbol == other.symbol;

  @override
  int get hashCode => symbol.hashCode;

  Map<String, String> toJson() => {
        'name': name,
        'symbol': symbol,
      };
}

class Quantity<N> {
  final Unit unit;
  final N value;

  Quantity(this.unit, this.value);

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is Quantity && unit == other.unit && value == other.value;

  @override
  int get hashCode => unit.hashCode ^ value.hashCode;

  @override
  String toString() {
    return '$value $unit';
  }
}
